/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name :                                                          */
/*                                                                       */
/*       Date : March 4, 1998                                            */
/* Updated at : March 4, 1998                                            */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/** Fusion Crossover:
    1. if p1[j]=p2[j], c[j]=p1[j]
    2. if p1[j]<>p2[j],
       2.1. let tcost = cost(p1)+cost(p2)
       2.2. let pr1 = cost(p1)/tcost
       2.3. let pr2 = cost(p2)/tcost
       2.4. generate a random number (r) between [0,1]
       2.5. if r<pr1, let c[j]=p1[j], else let c[j]=p2[j]
*/
/*************************************************************************/

#ifndef _SCPCrossoverFusion_h
#define _SCPCrossoverFusion_h

#include <CrossOverOperation.h>
#include <Chromosomes.h>
#include <ChromosomesBag.h>

#include "SCPChromosomes.h"


class SCPCrossoverFusion : public CrossOverOperation
{
   public :
      SCPCrossoverFusion();
      virtual ~SCPCrossoverFusion();
      virtual ChromosomesBag apply(Chromosomes*,Chromosomes*);
      virtual apply(Chromosomes*,Chromosomes*,Chromosomes**);
      virtual ChromosomesBag applyOLD(Chromosomes*,Chromosomes*);
      virtual ChromosomesBag apply(Chromosomes*,Chromosomes*,float);
      void applyf(Chromosomes*,Chromosomes*,SCPChromosomes*);

};// end of Class SCPCrossoverFusion

#endif
